from collections import defaultdict
from datetime import datetime
import re


with open('data/04.txt') as f:
    regex = re.compile(r'\[(\d{4}-\d{2}-\d{2} \d{2}:\d{2})\](?: Guard #(\d+)){0,1} (.+ .+)')
    events = []
    for line in f:
        dt, guard_id, event_type = regex.match(line).groups()
        dt = datetime.strptime(dt, '%Y-%m-%d %H:%M')
        guard_id = 0 if guard_id is None else int(guard_id)
        events.append([dt, guard_id, event_type])
    events.sort(key=lambda e: e[0])


by_minute = defaultdict(lambda: defaultdict(list))
by_guard = defaultdict(lambda: defaultdict(list))
total_time_asleep = defaultdict(int)

current_guard_id = None
spans = []
for event in events:
    dt, guard_id, event_type = event
    if event_type = 'begins shift':
        current_guard_id = guard_id
